//+------------------------------------------------------------------+
//|                                            PolyFitBands_v2.3.mq4 |
//|                             Copyright  2007-08, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-08, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   4
#property indicator_color1    LightSkyBlue
#property indicator_color2    DeepSkyBlue
#property indicator_color3    PaleVioletRed
#property indicator_color4    Red
#property indicator_width1    2
#property indicator_level1    0

//---- external variables
extern int     Price              =   0;   //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close)
extern int     Length             =  20;   //Number of bars for an evaluation
extern int     Degree             =   1;   //Degree of a Polynomial(no more 12)
extern int     PreSmooth          =   1;   //Period of Preliminary Smoothing
extern int     PreSmoothMode      =   3;   //Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern int     Signal             =   5;
extern int     SignalShift        =   0;
extern int     SignalMode         =   3;
extern double  K_Sigma            =   2.0;   //Multiplier of Sigma(Standard Deviation)
extern int     FitMode            =   1;   //Fitting Mode: 0-Fitting,1-Moving
extern int     CenterMode         =   1;   //Center Line Plot: 0-without,1-with 
extern int     BarsBack           =   0;   //Shift in history 
extern int     CountBars          =   0;   //Maximum Number of Bars(0-all Bars) 

extern bool   alertsOn            = true;
extern bool   alertsOnZeroCross   = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = false;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = true;
extern bool   alertsNotify        = false;
extern bool   alertsEmail         = false;
extern string SoundName           = "alert1.wav";
//---- indicator buffers
double Polynom[];
double OsLine[];
double UpBand[];
double DnBand[];
double UpLine[];
double DnLine[];
double signal[];


//---- global variables
double PriceArray[];
int cBars;
datetime pUpTime = 0, pDnTime = 0, pTime;
int outbars=0, inbars=0, onbars=0;
bool fTime = true;
//+---------------------------------------------------------------------------+
//| Custom indicator initialization function                                  |
//+---------------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
   if(BarsBack < 0) BarsBack = 0;
   //IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS )+2);
   
   SetIndexBuffer(0, OsLine);
   SetIndexBuffer(1, UpLine);
   SetIndexBuffer(2, DnLine);
   SetIndexBuffer(3, signal); SetIndexShift(3, SignalShift);
   SetIndexBuffer(4, Polynom);
   SetIndexBuffer(5, UpBand);
   SetIndexBuffer(6, DnBand);
      
   if(CountBars == 0) cBars = Bars - (Length+PreSmooth-2);
   else cBars = CountBars+1;
   
   SetIndexDrawBegin( 0,Bars-cBars-2);//+2*(Length+PreSmooth));
   SetIndexDrawBegin( 1,Bars-cBars-2);//+2*(Length+PreSmooth));
   SetIndexDrawBegin( 2,Bars-cBars-2);//+2*(Length+PreSmooth));
   SetIndexDrawBegin( 3,Bars-cBars-2);//+2*(Length+PreSmooth));
     
   string short_name="PolyFitBands("+Price+","+Length+","+Degree+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"PolyFitCenter");
   SetIndexLabel(1,"UpPolyBand");
   SetIndexLabel(2,"DnPolyBand");
   
   ArrayResize(PriceArray, Length);
      
   return(0);
}

double PolyFit(int mode,double price[],int deg,int len,int bar)
{
double   result=0,Sum=0;
double   AX[12,12],BX[12],ZX[12],Pow[12];
int      j,k,Row[12];  
static double CX[12];
      
   if (len<=1) Sum = price[bar];
   else
   {	
      if(mode == 1 || (mode == 0 && bar == -len+1))
      {
      for (j=1;j<=deg+1;j++) BX[j]=0;
		
         for (k=1;k<=len;k++) 
  	      {
  	      double YK=price[len-k];
  	      double XK=k;
  	      double Prod=1;
  	         for (j=1;j<=deg+1;j++)
            {
    	      BX[j]+= YK*Prod;
    	      Prod*=XK;
  		      }
         }
      
      for (j=0;j<=2*deg;j++) Pow[j]=0;
	
	   Pow[0]=len;
	
         for (k=1;k<=len;k++)
	      {
  	      XK=k;
  	      Prod=k;
  	         for (j=1;j<=2*deg;j++)
  	         {
    	      Pow[j]+= Prod;    	   
    	      Prod*= XK;
  		      }
         }	
	
	      for (j=1;j<=deg+1;j++)
	      {	
            for (int l=1;l<=deg+1;l++) 
  	         AX[j,l]=Pow[j+l-2];
         }	

	  for (j=1;j<=deg+1;j++) Row[j]=j;
  	
         for (int i=1;i<=deg;i++)
  	      {
  	         for (k=i+1;k<=deg+1;k++)
            {
               if(MathAbs(AX[Row[k],i]) > MathAbs(AX[Row[i],i]))
      	      {	
      	      int Temp=Row[i];
      	      Row[i]=Row[k];
      	      Row[k]=Temp;
               }
            }

            for (k=i+1;k<=deg+1;k++)
    	      {
    	      if(AX[Row[i],i]!=0) AX[Row[k],i]=AX[Row[k],i]/AX[Row[i],i];
    		      for (l=i+1;l<=deg+1;l++)
      	      AX[Row[k],l]=AX[Row[k],l]-AX[Row[k],i]*AX[Row[i],l];
    		   }
         }

      ZX[1]=BX[Row[1]];
      
         for (k=2;k<=deg+1;k++)
  	      {
  	      Sum=0;
         for (l=1;l<=k-1;l++) Sum+=AX[Row[k],l]*ZX[l];
  	   
  	      ZX[k]=BX[Row[k]]-Sum;
	      }
     
      if(AX[Row[deg+1],deg+1] != 0) CX[deg+1]=ZX[deg+1]/AX[Row[deg+1],deg+1];
      	
         for (k=deg;k>=1;k--)
  	      {
  	      Sum=0;
	    		
  	      for (l=k+1;l<=deg+1;l++) Sum += AX[Row[k],l]*CX[l]; 
  	      CX[k]=(ZX[k]-Sum)/AX[Row[k],k];
	      }
      }
      	  
	Sum=CX[deg+1];
	for (k=deg;k>=1;k--) Sum=CX[k]+Sum*(len + bar);
   }
   return (Sum);
}	
//+------------------------------------------------------------------+
//| PolyFitBands_v2.3                                                |
//+------------------------------------------------------------------+
double trend1[][1];
double trend2[][1];
int start()
{
   int i,r, j, k, m, shift, counted_bars=IndicatorCounted(), limit;
   if (ArrayRange(trend1,0)!= Bars) ArrayResize(trend1,Bars);
   if (ArrayRange(trend2,0)!= Bars) ArrayResize(trend2,Bars);    
   
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=cBars-1; 
         
   if (FitMode==1 && counted_bars > 0) {limit = Bars - counted_bars + BarsBack; int len = Length+PreSmooth;}
   else
   if (FitMode==0) {limit = Length + BarsBack; len = cBars - Length+1;} 
   
   if ( counted_bars < 1 || FitMode==0)
   { 
      for(i=1;i<len;i++)
      { 
      Polynom[cBars-i]=EMPTY_VALUE; 
      UpBand[cBars-i]=EMPTY_VALUE;
      DnBand[cBars-i]=EMPTY_VALUE;
      }
   }   
      
     
   for(shift=BarsBack;shift<limit;shift++ )
   {
      if(shift < cBars)
      {
         if((shift==BarsBack && FitMode==0) || (FitMode==1))
         {   
            for(j=0;j<Length;j++) 
            PriceArray[j] = iMA(NULL,0,PreSmooth,0,PreSmoothMode,Price,shift*FitMode + j + (1-FitMode)*BarsBack);
      
            double Sum=0;
            for(j=Length-1;j>=0;j--)
            {
            double poly = PolyFit(0,PriceArray,Degree,Length,-j); 
            double del = PriceArray[j] - poly; 
            Sum += del*del;
            if (FitMode==0) Polynom[j+BarsBack] = poly;  
            }
      
         if(FitMode==1) Polynom[shift] = poly; 
      
            if (Length-1 > 0 && Sum > 0)
            {
               if(Length < 32) double StdDev = MathSqrt(Sum/(Length-1));   
               else
               StdDev = MathSqrt(Sum/Length);       
            }
         }
      
      UpBand[shift] = Polynom[shift] + K_Sigma * StdDev;    
      DnBand[shift] = Polynom[shift] - K_Sigma * StdDev;
      if(CenterMode==0) Polynom[shift] = EMPTY_VALUE;
      
      //
      //
      //
      //
      //
      
      UpLine[shift] =  1;
      DnLine[shift] = -1;
      OsLine[shift] = (iMA(NULL,0,1,0,MODE_SMA,Price,shift)-Polynom[shift])/(K_Sigma * StdDev);
      }
      }
      //
      //
      //
      //
      //
      
      for (shift=limit; shift>=0; shift--) signal[shift] = iMAOnArray(OsLine,0,Signal,SignalShift,SignalMode,shift); 
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         trend1[r][0] = trend1[r-1][0];
         trend2[r][0] = trend2[r-1][0];
            if (OsLine[i]>0)         trend1[r][0] = 1;
            if (OsLine[i]<0)         trend1[r][0] =-1;   
            if (OsLine[i]>signal[i]) trend2[r][0] = 1;
            if (OsLine[i]<signal[i]) trend2[r][0] =-1;
            
      }   
   manageAlerts();        
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,0,whichBar))-1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnZeroCross && trend1[whichBar][0] != trend1[whichBar-1][0])
         {
            if (trend1[whichBar][0] ==  1) doAlert(time1,mess1,whichBar," Polyfit Bands crossed zero line up");
            if (trend1[whichBar][0] == -1) doAlert(time1,mess1,whichBar," Polyfit Bands crossed zero line down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend2[whichBar][0] != trend2[whichBar-1][0])
         {
            if (trend2[whichBar][0] ==  1) doAlert(time2,mess2,whichBar," Polyfit Bands crossed signal line up");
            if (trend2[whichBar][0] == -1) doAlert(time2,mess2,whichBar," Polyfit Bands crossed signal line down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+""+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Polyfit Bands "),message);
             if (alertsSound)   PlaySound(SoundName);
      }
}



